module Presyntax.Tokens where

import Data.Text (Text)

data TokenClass
  = TokVar Text
  | TokEof

  | TokLambda
  | TokArrow

  | TokOParen
  | TokOBrace
  | TokCParen
  | TokCBrace

  | TokStar
  | TokColon
  | TokEqual
  | TokComma

  | TokPi1
  | TokPi2
  deriving (Eq, Show, Ord)

data Token
  = Token { tokenClass   :: TokenClass
          , tokStartLine :: !Int
          , tokStartCol  :: !Int
          }
  deriving (Eq, Show, Ord)